/*
-- =====================================================================
-- CUSTOSUBG - Custo dos Sub-grupos do Manual e da Apresentao
-- =====================================================================
*/
CREATE OR REPLACE PROCEDURE CUSTOSUBG(
P_CDSEQCUSSG IN OUT CUSTOSEMA.CDSEQCUSSE%TYPE, -- Deve ser passado para o parmetro '0000000000'.
P_IDTIPMAN   IN VARCHAR DEFAULT 'M', -- 'M' - Manual Aprovado; 'A' - Manual da Apresentao.
P_CDSEQITEM  IN OUT NUMBER,
P_IDINSEREP  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Produto ; 'N' - No Insere Produto; 'P' - Insere Somente os Produtos Principais.
P_IDINSERER  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Receita ; 'N' - No Insere Receita; 'P' - Insere Somente as Receitas Principais.
P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
P_CDCIA      IN COMPANHIA.CDCIA%TYPE,
P_CDMANCIA   IN MANUALCIA.CDMANCIA%TYPE,
P_CDSERVICO  IN SUBGRUSEMA.CDSERVICO%TYPE,
/*P_CDCLASSE   IN SUBGRUSEMA.CDCLASSE%TYPE,
P_CDCICLO    IN SUBGRUSEMA.CDCICLO%TYPE,*/
P_CDSUBGRU   IN SUBGRUSEMA.CDSUBGRU%TYPE,
P_DTCUSTO    IN DATE,
P_CDOPERADOR IN OPERADOR.CDOPERADOR%TYPE,

VRCUSULCLIQSGR OUT NUMBER,
VRCUSULCBRUSGR OUT NUMBER,
VRCUSMEDLIQSGR OUT NUMBER,
VRCUSMEDBRUSGR OUT NUMBER
) AS
V_CDSEQCUSSG VARCHAR2(20);
V_IDINSEREP  VARCHAR(1);
/*V_CDMANCIA   MANUALCIA  .CDMANCIA%TYPE;
V_CDMANAP    MANUALCIAAP.CDMANAP%TYPE;*/

V_CDPRODUTO  PRODSUBSEMA.CDPRODUTO%TYPE;
V_SGUNIDADE  PRODSUBSEMA.SGUNIDADE%TYPE;
V_QTPRODUTO  PRODSUBSEMA.QTPRODSUMA%TYPE;
V_QTAPROVPRO PRODUTO.VRPEFATOCORR%TYPE;

V_CDRECEITA RECSUBSEMA.CDRECEITA%TYPE;
V_QTRENDREC RECSUBSEMA.QTRECSUMA%TYPE;

V_CUSULCLIQP_SAP NUMBER;
V_CUSULCLIQP_CAP NUMBER;
V_CUSULCBRUP_SAP NUMBER;
V_CUSULCBRUP_CAP NUMBER;
V_CUSMEDLIQP_SAP NUMBER;
V_CUSMEDLIQP_CAP NUMBER;
V_CUSMEDBRUP_SAP NUMBER;
V_CUSMEDBRUP_CAP NUMBER;

V_CUSULCLIQP_TSAP NUMBER;
V_CUSULCLIQP_TCAP NUMBER;
V_CUSULCBRUP_TSAP NUMBER;
V_CUSULCBRUP_TCAP NUMBER;
V_CUSMEDLIQP_TSAP NUMBER;
V_CUSMEDLIQP_TCAP NUMBER;
V_CUSMEDBRUP_TSAP NUMBER;
V_CUSMEDBRUP_TCAP NUMBER;

V_CUSULCLIQGERR_SAP NUMBER;
V_CUSULCLIQGERR_CAP NUMBER;
V_CUSULCBRUGERR_SAP NUMBER;
V_CUSULCBRUGERR_CAP NUMBER;
V_CUSMEDLIQGERR_SAP NUMBER;
V_CUSMEDLIQGERR_CAP NUMBER;
V_CUSMEDBRUGERR_SAP NUMBER;
V_CUSMEDBRUGERR_CAP NUMBER;

V_CUSULCLIQSGRT NUMBER;
V_CUSULCBRUSGRT NUMBER;
V_CUSMEDLIQSGRT NUMBER;
V_CUSMEDBRUSGRT NUMBER;

/* Produtos */
/* Manual Aprovado */
/*CURSOR C_PROMA IS
SELECT CDPRODUTO,SGUNIDADE,QTPRODSUMA
FROM PRODSUBSEMA
WHERE (CDFILIAL  = P_CDFILIAL ) AND
      (CDCIA     = P_CDCIA    ) AND
      (CDMANCIA  = P_CDMANCIA ) AND
      (CDSERVICO = P_CDSERVICO) AND
      --(CDCLASSE  = P_CDCLASSE ) AND
      --(CDCICLO   = P_CDCICLO  ) AND
      (CDSUBGRU  = P_CDSUBGRU );*/
CURSOR C_PROMA IS
SELECT PR.CDPRODUTO,PR.SGUNIDADE,CP.QTINSUMO QTPRODSUMA
FROM ESPEPROD EP, COMPPROD CP, PRODUTO PR
WHERE (EP.CDFILIAL      = P_CDFILIAL     ) AND
      (EP.CDCIA         = P_CDCIA        ) AND
      (EP.CDMANCIA      = P_CDMANCIA     ) AND
      (EP.CDPRODUTO     = P_CDSUBGRU     ) AND
      (EP.IDTPMANUAL    = 'M'            ) AND
      (CP.CDESPEPROD    = EP.CDESPEPROD  ) AND
      (CP.CDPRODUTO     = EP.CDPRODUTO   ) AND
      (CP.CDPRODUTOAUX  = P_CDSERVICO    ) AND
      (PR.CDPRODUTO     = CP.CDPRODINSUMO) AND
      (PR.IDPRODCOMISS    IS NULL        );
/* Manual de Apresentao */
CURSOR C_PROAP IS
SELECT CDPRODUTO,SGUNIDADE,QTPRODSUAP
FROM PRODSUBSEAP
WHERE (CDFILIAL = P_CDFILIAL) AND
      (CDCIA    = P_CDCIA   ) AND
      (CDMANAP  = P_CDMANCIA) AND
      (CDSUBGRU = P_CDSUBGRU);

/* Receitas */
/* Manual Aprovado */
/*CURSOR C_RECMA IS
SELECT CDRECEITA,QTRECSUMA
FROM RECSUBSEMA
WHERE (CDFILIAL  = P_CDFILIAL ) AND
      (CDCIA     = P_CDCIA    ) AND
      (CDMANCIA  = P_CDMANCIA ) AND
      (CDSERVICO = P_CDSERVICO) AND
      --(CDCLASSE  = P_CDCLASSE ) AND
      --(CDCICLO   = P_CDCICLO  ) AND
      (CDSUBGRU  = P_CDSUBGRU );*/
CURSOR C_RECMA IS
SELECT PR.CDPRODUTO CDRECEITA,CP.QTINSUMO QTRECSUMA
FROM ESPEPROD EP, COMPPROD CP, PRODUTO PR
WHERE (EP.CDFILIAL     = P_CDFILIAL     ) AND
      (EP.CDCIA        = P_CDCIA        ) AND
      (EP.CDMANCIA     = P_CDMANCIA     ) AND
      (EP.CDPRODUTO    = P_CDSUBGRU     ) AND
      (EP.IDTPMANUAL   = 'M'            ) AND
      (CP.CDESPEPROD   = EP.CDESPEPROD  ) AND
      (CP.CDPRODUTO    = EP.CDPRODUTO   ) AND
      (CP.CDPRODUTOAUX = P_CDSERVICO    ) AND
      (PR.CDPRODUTO    = CP.CDPRODINSUMO) AND
      (PR.IDPRODCOMISS = '3'            );
/* Manual de Apresentao */
CURSOR C_RECAP IS
SELECT CDRECEITA,QTRECSUAP
FROM RECSUBSEAP
WHERE (CDFILIAL  = P_CDFILIAL ) AND
      (CDCIA     = P_CDCIA    ) AND
      (CDMANAP   = P_CDMANCIA ) AND
      (CDSUBGRU  = P_CDSUBGRU );

BEGIN
   V_CUSULCLIQSGRT := 0;
   V_CUSULCBRUSGRT := 0;
   V_CUSMEDLIQSGRT := 0;
   V_CUSMEDBRUSGRT := 0;

	IF ((P_IDINSEREP <> 'N' ) OR
       (P_IDINSERER <> 'N' )) THEN

      IF P_CDSEQITEM IS NULL THEN
         P_CDSEQITEM := 0;
      END IF;
      P_CDSEQITEM := P_CDSEQITEM + 1;

      IF (P_CDSEQCUSSG = '0000000000') THEN
         NOVO_CODIGO('CUSTOSCOC'||P_CDFILIAL,V_CDSEQCUSSG,1);
         P_CDSEQCUSSG := SUBSTR(V_CDSEQCUSSG,11,10);
      END IF;
	END IF;

	IF (P_CDSEQCUSSG = '0000000000') AND
      ((P_IDINSEREP <> 'N' ) OR
       (P_IDINSERER <> 'N' )) THEN
		NOVO_CODIGO('CUSTOSCOC'||P_CDFILIAL,V_CDSEQCUSSG,1);
      P_CDSEQCUSSG := SUBSTR(V_CDSEQCUSSG,11,10);
   END IF;

   IF P_IDTIPMAN = 'M' THEN
      OPEN C_PROMA;
      OPEN C_RECMA;
   ELSIF P_IDTIPMAN = 'A' THEN
      OPEN C_PROAP;
      OPEN C_RECAP;
   END IF;

   LOOP
      IF P_IDTIPMAN = 'M' THEN
         FETCH C_PROMA
         INTO V_CDPRODUTO,V_SGUNIDADE,V_QTPRODUTO;
         EXIT WHEN C_PROMA%NOTFOUND;

         /*V_CDMANCIA := P_CDMANCIA;
         V_CDMANAP  := NULL;*/
      ELSIF P_IDTIPMAN = 'A' THEN
         FETCH C_PROAP
         INTO V_CDPRODUTO,V_SGUNIDADE,V_QTPRODUTO;
         EXIT WHEN C_PROAP%NOTFOUND;

         /*V_CDMANCIA := NULL;
         V_CDMANAP  := P_CDMANCIA;*/
      END IF;

      CUSTOPROD(P_CDFILIAL,P_CDCIA,V_CDPRODUTO,
                P_DTCUSTO,V_SGUNIDADE,V_QTPRODUTO,
                V_QTAPROVPRO,
                V_CUSULCLIQP_SAP,V_CUSULCLIQP_CAP,
                V_CUSULCBRUP_SAP,V_CUSULCBRUP_CAP,
                V_CUSMEDLIQP_SAP,V_CUSMEDLIQP_CAP,
                V_CUSMEDBRUP_SAP,V_CUSMEDBRUP_CAP,
                V_CUSULCLIQP_TSAP,V_CUSULCLIQP_TCAP,
                V_CUSULCBRUP_TSAP,V_CUSULCBRUP_TCAP,
                V_CUSMEDLIQP_TSAP,V_CUSMEDLIQP_TCAP,
                V_CUSMEDBRUP_TSAP,V_CUSMEDBRUP_TCAP);

      V_CUSULCLIQSGRT := V_CUSULCLIQSGRT + V_CUSULCLIQP_TCAP;
      V_CUSULCBRUSGRT := V_CUSULCBRUSGRT + V_CUSULCBRUP_TCAP;
      V_CUSMEDLIQSGRT := V_CUSMEDLIQSGRT + V_CUSMEDLIQP_TCAP;
      V_CUSMEDBRUSGRT := V_CUSMEDBRUSGRT + V_CUSMEDBRUP_TCAP;

      IF P_IDINSEREP <> 'N' THEN
         INSERT INTO CUSTOPROCIA
         (/*CDFILIPRIPC,*/CDRECPRIPC,CDSEQCUSPC,CDFILIAL,
          CDCIA,CDMANCIA,/*CDMANAP,*/CDSERVICO,
          CDSUBGRU,CDSEQITEMCP,
          CDPRODUTO,QTCUSPROCIA,
          DTCUSPROCIA,DTHRGERPCIA,CDOPERPCIA,QTAPROVPCIA,
          VRULLIQPRCIA,VRULBRUPRCIA,
          VRMELIQPRCIA,VRMEBRUPRCIA,
          VRUCLSAPPCIA,VRUCBSAPPCIA,
          VRMELSAPPCIA,VRMEBSAPPCIA)
         VALUES
         (/*NULL,*/NULL,P_CDSEQCUSSG,P_CDFILIAL,
          P_CDCIA,P_CDMANCIA,/*V_CDMANCIA,V_CDMANAP,*/P_CDSERVICO,
          P_CDSUBGRU,LPAD(TO_CHAR(P_CDSEQITEM),10,'0'),
          V_CDPRODUTO,V_QTPRODUTO,
          P_DTCUSTO,SYSDATE,P_CDOPERADOR,V_QTAPROVPRO,
          V_CUSULCLIQP_CAP,V_CUSULCBRUP_CAP,
          V_CUSMEDLIQP_CAP,V_CUSMEDBRUP_CAP,
          V_CUSULCLIQP_SAP,V_CUSULCBRUP_SAP,
          V_CUSMEDLIQP_SAP,V_CUSMEDBRUP_SAP);
      END IF;
   END LOOP;

	IF P_IDINSEREP = 'P' THEN
		V_IDINSEREP := 'N';
   ELSE
		V_IDINSEREP := P_IDINSEREP;
   END IF;

   LOOP
      IF P_IDTIPMAN = 'M' THEN
         FETCH C_RECMA
         INTO V_CDRECEITA,V_QTRENDREC;
         EXIT WHEN C_RECMA%NOTFOUND;
      ELSIF P_IDTIPMAN = 'A' THEN
         FETCH C_RECAP
         INTO V_CDRECEITA,V_QTRENDREC;
         EXIT WHEN C_RECAP%NOTFOUND;
      END IF;
      VERIFICA_ESPEPROD('P',V_CDRECEITA); /* Verifica a especificao para receitas do manual */

      CUSTOREC(P_CDSEQCUSSG,P_IDTIPMAN,P_CDSEQITEM,'C',V_IDINSEREP,
               P_IDINSERER,P_CDFILIAL,P_CDCIA,P_CDMANCIA,P_CDSERVICO,
               /*P_CDCLASSE,P_CDCICLO,*/P_CDSUBGRU,V_CDRECEITA,
               NULL,V_QTRENDREC,P_DTCUSTO,P_CDOPERADOR,
               V_CUSULCLIQGERR_SAP,V_CUSULCLIQGERR_CAP,
               V_CUSULCBRUGERR_SAP,V_CUSULCBRUGERR_CAP,
               V_CUSMEDLIQGERR_SAP,V_CUSMEDLIQGERR_CAP,
               V_CUSMEDBRUGERR_SAP,V_CUSMEDBRUGERR_CAP);

      V_CUSULCLIQSGRT := V_CUSULCLIQSGRT + V_CUSULCLIQGERR_CAP;
      V_CUSULCBRUSGRT := V_CUSULCBRUSGRT + V_CUSULCBRUGERR_CAP;
      V_CUSMEDLIQSGRT := V_CUSMEDLIQSGRT + V_CUSMEDLIQGERR_CAP;
      V_CUSMEDBRUSGRT := V_CUSMEDBRUSGRT + V_CUSMEDBRUGERR_CAP;
   END LOOP;

   VRCUSULCLIQSGR := V_CUSULCLIQSGRT;
   VRCUSULCBRUSGR := V_CUSULCBRUSGRT;
   VRCUSMEDLIQSGR := V_CUSMEDLIQSGRT;
   VRCUSMEDBRUSGR := V_CUSMEDBRUSGRT;
END;
/
