/*
   Tabela ENDEFORN: Cadastro de Endereo de Fornecedor
   Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela de ENDEFORN.
   Objetivo: Gerar log de alteraes realizadas na tabela de ENDEFORN, utilizando a tabela geral de Logs
   de Operaes.
*/

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_GER_ENDEFORN' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)
DROP TRIGGER LOG_GER_ENDEFORN
GO

CREATE TRIGGER LOG_GER_ENDEFORN
ON ENDEFORN
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_TIPO                VARCHAR(1);
   DECLARE @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE @V_DSSERVERRDM         VARCHAR(20);
   DECLARE @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE @V_DSREMOTEOPER        VARCHAR(12);
   DECLARE @V_DESC                VARCHAR(500);
   DECLARE @V_CDFILLOGOPER        VARCHAR(4);
   DECLARE @V_ITPESQ              VARCHAR(40);
   DECLARE @V_NMOPERADOR          VARCHAR(40);
   DECLARE @V_DSTPENDEFORN        VARCHAR(20);

   /*VARIAVEIS DO C_CURSOR*/
   DECLARE @V_IDCOMANDO           VARCHAR(1);
   DECLARE @V_NEW_CDFORNECED      VARCHAR(21);
   DECLARE @V_NEW_IDTPENDEFORN    VARCHAR(1);
   DECLARE @V_NEW_DSENDEFORN      VARCHAR(50);
   DECLARE @V_NEW_NRENDEFORNSEP   VARCHAR(5);
   DECLARE @V_NEW_DSCOMPENDFOR    VARCHAR(200);
   DECLARE @V_NEW_CDLOGRADOURO    VARCHAR(4);
   DECLARE @V_NEW_NMBAIRFORN      VARCHAR(30);
   DECLARE @V_NEW_CDPAIS          VARCHAR(4);
   DECLARE @V_NEW_SGESTADO        VARCHAR(2);
   DECLARE @V_NEW_CDMUNICIPIO     VARCHAR(4);
   DECLARE @V_NEW_NMCONTFORN      VARCHAR(30);
   DECLARE @V_NEW_DSEMAILFORN     VARCHAR(40);
   DECLARE @V_NEW_NRDDDTELEFORN   VARCHAR(3);
   DECLARE @V_NEW_NRTELEFORN      VARCHAR(25);
   DECLARE @V_NEW_NRRAMALFORN     VARCHAR(4);
   DECLARE @V_NEW_NRDDDTELEFORN1  VARCHAR(3);
   DECLARE @V_NEW_NRTELEFORN1     VARCHAR(25);
   DECLARE @V_NEW_NRRAMALFORN1    VARCHAR(4);
   DECLARE @V_NEW_NRDDDCELULARFOR VARCHAR(3);
   DECLARE @V_NEW_NRCELULARFOR    VARCHAR(25);
   DECLARE @V_NEW_NRDDDTELRESIFOR VARCHAR(3);
   DECLARE @V_NEW_NRTELRESIFOR    VARCHAR(25);
   DECLARE @V_NEW_NRDDDFAXFORN    VARCHAR(3);
   DECLARE @V_NEW_NRFAXFORN       VARCHAR(25);
   DECLARE @V_NEW_DSEMAILFORNNFE  VARCHAR(120);

   DECLARE @V_OLD_CDFORNECED      VARCHAR(21);
   DECLARE @V_OLD_IDTPENDEFORN    VARCHAR(1);
   DECLARE @V_OLD_DSENDEFORN      VARCHAR(50);
   DECLARE @V_OLD_NRENDEFORNSEP   VARCHAR(5);
   DECLARE @V_OLD_DSCOMPENDFOR    VARCHAR(200);
   DECLARE @V_OLD_CDLOGRADOURO    VARCHAR(4);
   DECLARE @V_OLD_NMBAIRFORN      VARCHAR(30);
   DECLARE @V_OLD_CDPAIS          VARCHAR(4);
   DECLARE @V_OLD_SGESTADO        VARCHAR(2);
   DECLARE @V_OLD_CDMUNICIPIO     VARCHAR(4);
   DECLARE @V_OLD_NMCONTFORN      VARCHAR(30);
   DECLARE @V_OLD_DSEMAILFORN     VARCHAR(40);
   DECLARE @V_OLD_NRDDDTELEFORN   VARCHAR(3);
   DECLARE @V_OLD_NRTELEFORN      VARCHAR(25);
   DECLARE @V_OLD_NRRAMALFORN     VARCHAR(4);
   DECLARE @V_OLD_NRDDDTELEFORN1  VARCHAR(3);
   DECLARE @V_OLD_NRTELEFORN1     VARCHAR(25);
   DECLARE @V_OLD_NRRAMALFORN1    VARCHAR(4);
   DECLARE @V_OLD_NRDDDCELULARFOR VARCHAR(3);
   DECLARE @V_OLD_NRCELULARFOR    VARCHAR(25);
   DECLARE @V_OLD_NRDDDTELRESIFOR VARCHAR(3);
   DECLARE @V_OLD_NRTELRESIFOR    VARCHAR(25);
   DECLARE @V_OLD_NRDDDFAXFORN    VARCHAR(3);
   DECLARE @V_OLD_NRFAXFORN       VARCHAR(25);
   DECLARE @V_OLD_DSEMAILFORNNFE  VARCHAR(120);

BEGIN
   /* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_TIPO         = '0';
   SET @V_DESC         = '';
   SET @V_ITPESQ       = '';
   SET @V_NMOPERADOR   = '';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'D' IDCOMANDO,
             CDFORNECED,
             IDTPENDEFORN,
             DSENDEFORN,
             NRENDEFORNSEP,
             DSCOMPENDFOR,
             CDLOGRADOURO,
             NMBAIRFORN,
             CDPAIS,
             SGESTADO,
             CDMUNICIPIO,
             NMCONTFORN,
             DSEMAILFORN,
             NRDDDTELEFORN,
             NRTELEFORN,
             NRRAMALFORN,
             NRDDDTELEFORN1,
             NRTELEFORN1,
             NRRAMALFORN1,
             NRDDDCELULARFOR,
             NRCELULARFOR,
             NRDDDTELRESIFOR,
             NRTELRESIFOR,
             NRDDDFAXFORN,
             NRFAXFORN,
             DSEMAILFORNNFE,

             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL
      FROM
         DELETED
      WHERE
         CDFORNECED NOT IN (SELECT CDFORNECED FROM INSERTED)
      UNION ALL

      SELECT 'U' IDCOMANDO,
             DELETED.CDFORNECED,
             DELETED.IDTPENDEFORN,
             DELETED.DSENDEFORN,
             DELETED.NRENDEFORNSEP,
             DELETED.DSCOMPENDFOR,
             DELETED.CDLOGRADOURO,
             DELETED.NMBAIRFORN,
             DELETED.CDPAIS,
             DELETED.SGESTADO,
             DELETED.CDMUNICIPIO,
             DELETED.NMCONTFORN,
             DELETED.DSEMAILFORN,
             DELETED.NRDDDTELEFORN,
             DELETED.NRTELEFORN,
             DELETED.NRRAMALFORN,
             DELETED.NRDDDTELEFORN1,
             DELETED.NRTELEFORN1,
             DELETED.NRRAMALFORN1,
             DELETED.NRDDDCELULARFOR,
             DELETED.NRCELULARFOR,
             DELETED.NRDDDTELRESIFOR,
             DELETED.NRTELRESIFOR,
             DELETED.NRDDDFAXFORN,
             DELETED.NRFAXFORN,
             DELETED.DSEMAILFORNNFE,

             INSERTED.CDFORNECED,
             INSERTED.IDTPENDEFORN,
             INSERTED.DSENDEFORN,
             INSERTED.NRENDEFORNSEP,
             INSERTED.DSCOMPENDFOR,
             INSERTED.CDLOGRADOURO,
             INSERTED.NMBAIRFORN,
             INSERTED.CDPAIS,
             INSERTED.SGESTADO,
             INSERTED.CDMUNICIPIO,
             INSERTED.NMCONTFORN,
             INSERTED.DSEMAILFORN,
             INSERTED.NRDDDTELEFORN,
             INSERTED.NRTELEFORN,
             INSERTED.NRRAMALFORN,
             INSERTED.NRDDDTELEFORN1,
             INSERTED.NRTELEFORN1,
             INSERTED.NRRAMALFORN1,
             INSERTED.NRDDDCELULARFOR,
             INSERTED.NRCELULARFOR,
             INSERTED.NRDDDTELRESIFOR,
             INSERTED.NRTELRESIFOR,
             INSERTED.NRDDDFAXFORN,
             INSERTED.NRFAXFORN,
             INSERTED.DSEMAILFORNNFE
      FROM
         INSERTED, DELETED
      WHERE
         INSERTED.CDFORNECED = DELETED.CDFORNECED
      UNION ALL

      SELECT 'I' IDCOMANDO,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,

             CDFORNECED,
             IDTPENDEFORN,
             DSENDEFORN,
             NRENDEFORNSEP,
             DSCOMPENDFOR,
             CDLOGRADOURO,
             NMBAIRFORN,
             CDPAIS,
             SGESTADO,
             CDMUNICIPIO,
             NMCONTFORN,
             DSEMAILFORN,
             NRDDDTELEFORN,
             NRTELEFORN,
             NRRAMALFORN,
             NRDDDTELEFORN1,
             NRTELEFORN1,
             NRRAMALFORN1,
             NRDDDCELULARFOR,
             NRCELULARFOR,
             NRDDDTELRESIFOR,
             NRTELRESIFOR,
             NRDDDFAXFORN,
             NRFAXFORN,
             DSEMAILFORNNFE
      FROM INSERTED
      WHERE CDFORNECED NOT IN (SELECT CDFORNECED FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                    @V_OLD_CDFORNECED,      @V_OLD_IDTPENDEFORN, @V_OLD_DSENDEFORN,      @V_OLD_NRENDEFORNSEP,
                                    @V_OLD_DSCOMPENDFOR,    @V_OLD_CDLOGRADOURO, @V_OLD_NMBAIRFORN,      @V_OLD_CDPAIS,
                                    @V_OLD_SGESTADO,        @V_OLD_CDMUNICIPIO,  @V_OLD_NMCONTFORN,      @V_OLD_DSEMAILFORN,
                                    @V_OLD_NRDDDTELEFORN,   @V_OLD_NRTELEFORN,   @V_OLD_NRRAMALFORN,     @V_OLD_NRDDDTELEFORN1,
                                    @V_OLD_NRTELEFORN1,     @V_OLD_NRRAMALFORN1, @V_OLD_NRDDDCELULARFOR, @V_OLD_NRCELULARFOR,
                                    @V_OLD_NRDDDTELRESIFOR, @V_OLD_NRTELRESIFOR, @V_OLD_NRDDDFAXFORN,    @V_OLD_NRFAXFORN,
                                    @V_OLD_DSEMAILFORNNFE,

                                    @V_NEW_CDFORNECED,      @V_NEW_IDTPENDEFORN,      @V_NEW_DSENDEFORN,      @V_NEW_NRENDEFORNSEP,
                                    @V_NEW_DSCOMPENDFOR,    @V_NEW_CDLOGRADOURO, @V_NEW_NMBAIRFORN,      @V_NEW_CDPAIS,
                                    @V_NEW_SGESTADO,        @V_NEW_CDMUNICIPIO,  @V_NEW_NMCONTFORN,      @V_NEW_DSEMAILFORN,
                                    @V_NEW_NRDDDTELEFORN,   @V_NEW_NRTELEFORN,   @V_NEW_NRRAMALFORN,     @V_NEW_NRDDDTELEFORN1,
                                    @V_NEW_NRTELEFORN1,     @V_NEW_NRRAMALFORN1, @V_NEW_NRDDDCELULARFOR, @V_NEW_NRCELULARFOR,
                                    @V_NEW_NRDDDTELRESIFOR, @V_NEW_NRTELRESIFOR, @V_NEW_NRDDDFAXFORN,    @V_NEW_NRFAXFORN,
                                    @V_NEW_DSEMAILFORNNFE;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_IDCOMANDO = 'D' BEGIN /*DELETING*/
            IF @V_OLD_CDFORNECED IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CdForneced=' + @V_OLD_CDFORNECED;
            END;

            IF @V_OLD_IDTPENDEFORN IS NOT NULL BEGIN
               IF @V_OLD_IDTPENDEFORN = 'P' BEGIN
                  SET @V_DSTPENDEFORN = '-Principal';
               END
               ELSE IF @V_OLD_IDTPENDEFORN = 'C' BEGIN
                  SET @V_DSTPENDEFORN = '-Pagamento';
               END
               ELSE IF @V_OLD_IDTPENDEFORN = 'E' BEGIN
                  SET @V_DSTPENDEFORN = '-Exterior';
               END
               ELSE BEGIN
                  SET @V_DSTPENDEFORN = '-Exportao';
               END;
               SET @V_DESC = @V_DESC + ' TipoEnde=' + @V_OLD_IDTPENDEFORN + @V_DSTPENDEFORN;
            END;

            IF @V_OLD_DSENDEFORN	IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DescEndereo=' + @V_OLD_DSENDEFORN;
            END;

            IF @V_OLD_NRENDEFORNSEP	IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Nmero=' + @V_OLD_NRENDEFORNSEP;
            END;

            IF @V_OLD_DSCOMPENDFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Complemento=' + @V_OLD_DSCOMPENDFOR;
            END;

            IF @V_OLD_CDLOGRADOURO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Logradouro=' + @V_OLD_CDLOGRADOURO;
            END;

            IF @V_OLD_NMBAIRFORN	IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' NmBairro=' + @V_OLD_NMBAIRFORN;
            END;

            IF @V_OLD_CDPAIS IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Pas=' + @V_OLD_CDPAIS;
            END;

            IF @V_OLD_SGESTADO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SgEstado=' + @V_OLD_SGESTADO;
            END;

            IF @V_OLD_CDMUNICIPIO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' CdMunicpio=' + @V_OLD_CDMUNICIPIO;
            END;

            IF @V_OLD_NMCONTFORN	IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Contato=' + @V_OLD_NMCONTFORN;
            END;

            IF @V_OLD_DSEMAILFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Email=' + @V_OLD_DSEMAILFORN;
            END;

            IF @V_OLD_NRDDDTELEFORN	IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDTel1=' + @V_OLD_NRDDDTELEFORN;
            END;

            IF @V_OLD_NRTELEFORN	IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Tel1=' + @V_OLD_NRTELEFORN;
            END;

            IF @V_OLD_NRRAMALFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' RamalTel1=' + @V_OLD_NRRAMALFORN;
            END;

            IF @V_OLD_NRDDDTELEFORN1 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDTel2=' + @V_OLD_NRDDDTELEFORN1;
            END;

            IF @V_OLD_NRTELEFORN1 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Tel2=' + @V_OLD_NRTELEFORN1;
            END;

            IF @V_OLD_NRRAMALFORN1 IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' RamalTel2=' + @V_OLD_NRRAMALFORN1;
            END;

            IF @V_OLD_NRDDDCELULARFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDCel=' + @V_OLD_NRDDDCELULARFOR;
            END;

            IF @V_OLD_NRCELULARFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TelCel=' + @V_OLD_NRCELULARFOR;
            END;

            IF @V_OLD_NRDDDTELRESIFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDResiden=' + @V_OLD_NRDDDTELRESIFOR;
            END;

            IF @V_OLD_NRTELRESIFOR IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TelResiden=' + @V_OLD_NRTELRESIFOR;
            END;

            IF @V_OLD_NRDDDFAXFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DDDFax=' + @V_OLD_NRDDDFAXFORN;
            END;

            IF @V_OLD_NRFAXFORN IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' TelFax=' + @V_OLD_NRFAXFORN;
            END;

            IF @V_OLD_DSEMAILFORNNFE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' EmailNFe=' + @V_OLD_DSEMAILFORNNFE;
            END;

            SET @V_TIPO   = '3';
            SET @V_ITPESQ = @V_OLD_CDFORNECED;
         END
         ELSE IF @V_IDCOMANDO = 'U' BEGIN /*UPDATING*/
            IF (ISNULL(@V_NEW_CDFORNECED,'!')      <> ISNULL(@V_OLD_CDFORNECED,'!'))      OR
               (ISNULL(@V_NEW_IDTPENDEFORN,'!')    <> ISNULL(@V_OLD_IDTPENDEFORN,'!'))    OR
               (ISNULL(@V_NEW_DSENDEFORN,'!')      <> ISNULL(@V_OLD_DSENDEFORN,'!'))      OR
               (ISNULL(@V_NEW_NRENDEFORNSEP,'!')   <> ISNULL(@V_OLD_NRENDEFORNSEP,'!'))   OR
               (ISNULL(@V_NEW_DSCOMPENDFOR,'!')    <> ISNULL(@V_OLD_DSCOMPENDFOR,'!'))    OR
               (ISNULL(@V_NEW_CDLOGRADOURO,'!')    <> ISNULL(@V_OLD_CDLOGRADOURO,'!'))    OR
               (ISNULL(@V_NEW_NMBAIRFORN,'!')      <> ISNULL(@V_OLD_NMBAIRFORN,'!'))      OR
               (ISNULL(@V_NEW_CDPAIS,'!')          <> ISNULL(@V_OLD_CDPAIS,'!'))          OR
               (ISNULL(@V_NEW_SGESTADO,'!')        <> ISNULL(@V_OLD_SGESTADO,'!'))        OR
               (ISNULL(@V_NEW_CDMUNICIPIO,'!')     <> ISNULL(@V_OLD_CDMUNICIPIO,'!'))     OR
               (ISNULL(@V_NEW_NMCONTFORN,'!')      <> ISNULL(@V_OLD_NMCONTFORN,'!'))      OR
               (ISNULL(@V_NEW_DSEMAILFORN,'!')     <> ISNULL(@V_OLD_DSEMAILFORN,'!'))     OR
               (ISNULL(@V_NEW_NRDDDTELEFORN,'!')   <> ISNULL(@V_OLD_NRDDDTELEFORN,'!'))   OR
               (ISNULL(@V_NEW_NRTELEFORN,'!')      <> ISNULL(@V_OLD_NRTELEFORN,'!'))      OR
               (ISNULL(@V_NEW_NRRAMALFORN,'!')     <> ISNULL(@V_OLD_NRRAMALFORN,'!'))     OR
               (ISNULL(@V_NEW_NRDDDTELEFORN1,'!')  <> ISNULL(@V_OLD_NRDDDTELEFORN1,'!'))  OR
               (ISNULL(@V_NEW_NRTELEFORN1,'!')     <> ISNULL(@V_OLD_NRTELEFORN1,'!'))     OR
               (ISNULL(@V_NEW_NRRAMALFORN1,'!')    <> ISNULL(@V_OLD_NRRAMALFORN1,'!'))    OR
               (ISNULL(@V_NEW_NRDDDCELULARFOR,'!') <> ISNULL(@V_OLD_NRDDDCELULARFOR,'!')) OR
               (ISNULL(@V_NEW_NRCELULARFOR,'!')    <> ISNULL(@V_OLD_NRCELULARFOR,'!'))    OR
               (ISNULL(@V_NEW_NRDDDTELRESIFOR,'!') <> ISNULL(@V_OLD_NRDDDTELRESIFOR,'!')) OR
               (ISNULL(@V_NEW_NRTELRESIFOR,'!')    <> ISNULL(@V_OLD_NRTELRESIFOR,'!'))    OR
               (ISNULL(@V_NEW_NRDDDFAXFORN,'!')    <> ISNULL(@V_OLD_NRDDDFAXFORN,'!'))    OR
               (ISNULL(@V_NEW_NRFAXFORN,'!')       <> ISNULL(@V_OLD_NRFAXFORN,'!'))       OR
               (ISNULL(@V_NEW_DSEMAILFORNNFE,'!')  <> ISNULL(@V_OLD_DSEMAILFORNNFE,'!'))  BEGIN

               IF (ISNULL(@V_NEW_CDFORNECED,'!') <> ISNULL(@V_OLD_CDFORNECED,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CdForneced=' + @V_NEW_CDFORNECED;
               END;

               IF @V_OLD_IDTPENDEFORN IS NOT NULL BEGIN
                  IF @V_OLD_IDTPENDEFORN = 'P' BEGIN
                     SET @V_DSTPENDEFORN = '-Principal';
                  END
                  ELSE IF @V_OLD_IDTPENDEFORN = 'C' BEGIN
                     SET @V_DSTPENDEFORN = '-Pagamento';
                  END
                  ELSE IF @V_OLD_IDTPENDEFORN = 'E' BEGIN
                     SET @V_DSTPENDEFORN = '-Exterior';
                  END
                  ELSE BEGIN
                     SET @V_DSTPENDEFORN = '-Exportao';
                  END;
                  SET @V_DESC = @V_DESC + ' TipoEnde=' + @V_OLD_IDTPENDEFORN + @V_DSTPENDEFORN;
               END;

               IF (ISNULL(@V_NEW_DSENDEFORN,'!') <> ISNULL(@V_OLD_DSENDEFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' DescEndereo=' + @V_NEW_DSENDEFORN;
               END;

               IF (ISNULL(@V_NEW_NRENDEFORNSEP,'!') <> ISNULL(@V_OLD_NRENDEFORNSEP,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Nmero=' + @V_NEW_NRENDEFORNSEP;
               END;

               IF (ISNULL(@V_NEW_DSCOMPENDFOR,'!') <> ISNULL(@V_OLD_DSCOMPENDFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Complemento=' + @V_NEW_DSCOMPENDFOR;
               END;

               IF (ISNULL(@V_NEW_CDLOGRADOURO,'!') <> ISNULL(@V_OLD_CDLOGRADOURO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Logradouro=' + @V_NEW_CDLOGRADOURO;
               END;

               IF (ISNULL(@V_NEW_NMBAIRFORN,'!') <> ISNULL(@V_OLD_NMBAIRFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' NmBairro=' + @V_NEW_NMBAIRFORN;
               END;

               IF (ISNULL(@V_NEW_CDPAIS,'!') <> ISNULL(@V_OLD_CDPAIS,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Pas=' + @V_NEW_CDPAIS;
               END;

               IF (ISNULL(@V_NEW_SGESTADO,'!') <> ISNULL(@V_OLD_SGESTADO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' SgEstado=' + @V_NEW_SGESTADO;
               END;

               IF (ISNULL(@V_NEW_CDMUNICIPIO,'!') <> ISNULL(@V_OLD_CDMUNICIPIO,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' CdMunicpio=' + @V_NEW_CDMUNICIPIO;
               END;

               IF (ISNULL(@V_NEW_NMCONTFORN,'!') <> ISNULL(@V_OLD_NMCONTFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Contato=' + @V_NEW_NMCONTFORN;
               END;

               IF (ISNULL(@V_NEW_DSEMAILFORN,'!') <> ISNULL(@V_OLD_DSEMAILFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Email=' + @V_NEW_DSEMAILFORN;
               END;

               IF (ISNULL(@V_NEW_NRDDDTELEFORN,'!') <> ISNULL(@V_OLD_NRDDDTELEFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' DDDTel1=' + @V_NEW_NRDDDTELEFORN;
               END;

               IF (ISNULL(@V_NEW_NRTELEFORN,'!') <> ISNULL(@V_OLD_NRTELEFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Tel1=' + @V_NEW_NRTELEFORN;
               END;

               IF (ISNULL(@V_NEW_NRRAMALFORN,'!') <> ISNULL(@V_OLD_NRRAMALFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' RamalTel1=' + @V_NEW_NRRAMALFORN;
               END;

               IF (ISNULL(@V_NEW_NRDDDTELEFORN1,'!') <> ISNULL(@V_OLD_NRDDDTELEFORN1,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' DDDTel2=' + @V_NEW_NRDDDTELEFORN1;
               END;

               IF (ISNULL(@V_NEW_NRTELEFORN1,'!') <> ISNULL(@V_OLD_NRTELEFORN1,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Tel2=' + @V_NEW_NRTELEFORN1;
               END;

               IF (ISNULL(@V_NEW_NRRAMALFORN1,'!') <> ISNULL(@V_OLD_NRRAMALFORN1,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' RamalTel2=' + @V_NEW_NRRAMALFORN1;
               END;

               IF (ISNULL(@V_NEW_NRDDDCELULARFOR,'!') <> ISNULL(@V_OLD_NRDDDCELULARFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' DDDCel=' + @V_NEW_NRDDDCELULARFOR;
               END;

               IF (ISNULL(@V_NEW_NRCELULARFOR,'!') <> ISNULL(@V_OLD_NRCELULARFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TelCel=' + @V_NEW_NRCELULARFOR;
               END;

               IF (ISNULL(@V_NEW_NRDDDTELRESIFOR,'!') <> ISNULL(@V_OLD_NRDDDTELRESIFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' DDDResiden=' + @V_NEW_NRDDDTELRESIFOR;
               END;

               IF (ISNULL(@V_NEW_NRTELRESIFOR,'!') <> ISNULL(@V_OLD_NRTELRESIFOR,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TelResiden=' + @V_NEW_NRTELRESIFOR;
               END;

               IF (ISNULL(@V_NEW_NRDDDFAXFORN,'!') <> ISNULL(@V_OLD_NRDDDFAXFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' DDDFax=' + @V_NEW_NRDDDFAXFORN;
               END;

               IF (ISNULL(@V_NEW_NRFAXFORN,'!') <> ISNULL(@V_OLD_NRFAXFORN,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' TelFax=' + @V_NEW_NRFAXFORN;
               END;

               IF (ISNULL(@V_NEW_DSEMAILFORNNFE,'!') <> ISNULL(@V_OLD_DSEMAILFORNNFE,'!')) BEGIN
                  SET @V_DESC = @V_DESC + ' EmailNFe=' + @V_NEW_DSEMAILFORNNFE;
               END;

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_OLD_CDFORNECED;
            END;
         END;
         ELSE BEGIN /*INSERT*/
            IF (ISNULL(@V_NEW_CDFORNECED,'!') <> ISNULL(@V_OLD_CDFORNECED,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CdForneced=' + @V_NEW_CDFORNECED;
            END;

            IF @V_OLD_IDTPENDEFORN IS NOT NULL BEGIN
               IF @V_OLD_IDTPENDEFORN = 'P' BEGIN
                  SET @V_DSTPENDEFORN = '-Principal';
               END
               ELSE IF @V_OLD_IDTPENDEFORN = 'C' BEGIN
                  SET @V_DSTPENDEFORN = '-Pagamento';
               END
               ELSE IF @V_OLD_IDTPENDEFORN = 'E' BEGIN
                  SET @V_DSTPENDEFORN = '-Exterior';
               END
               ELSE BEGIN
                  SET @V_DSTPENDEFORN = '-Exportao';
               END;
               SET @V_DESC = @V_DESC + ' TipoEnde=' + @V_OLD_IDTPENDEFORN + @V_DSTPENDEFORN;
            END;

            IF (ISNULL(@V_NEW_DSENDEFORN,'!') <> ISNULL(@V_OLD_DSENDEFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' DescEndereo=' + @V_NEW_DSENDEFORN;
            END;

            IF (ISNULL(@V_NEW_NRENDEFORNSEP,'!') <> ISNULL(@V_OLD_NRENDEFORNSEP,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Nmero=' + @V_NEW_NRENDEFORNSEP;
            END;

            IF (ISNULL(@V_NEW_DSCOMPENDFOR,'!') <> ISNULL(@V_OLD_DSCOMPENDFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Complemento=' + @V_NEW_DSCOMPENDFOR;
            END;

            IF (ISNULL(@V_NEW_CDLOGRADOURO,'!') <> ISNULL(@V_OLD_CDLOGRADOURO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Logradouro=' + @V_NEW_CDLOGRADOURO;
            END;

            IF (ISNULL(@V_NEW_NMBAIRFORN,'!') <> ISNULL(@V_OLD_NMBAIRFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' NmBairro=' + @V_NEW_NMBAIRFORN;
            END;

            IF (ISNULL(@V_NEW_CDPAIS,'!') <> ISNULL(@V_OLD_CDPAIS,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Pas=' + @V_NEW_CDPAIS;
            END;

            IF (ISNULL(@V_NEW_SGESTADO,'!') <> ISNULL(@V_OLD_SGESTADO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' SgEstado=' + @V_NEW_SGESTADO;
            END;

            IF (ISNULL(@V_NEW_CDMUNICIPIO,'!') <> ISNULL(@V_OLD_CDMUNICIPIO,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' CdMunicpio=' + @V_NEW_CDMUNICIPIO;
            END;

            IF (ISNULL(@V_NEW_NMCONTFORN,'!') <> ISNULL(@V_OLD_NMCONTFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Contato=' + @V_NEW_NMCONTFORN;
            END;

            IF (ISNULL(@V_NEW_DSEMAILFORN,'!') <> ISNULL(@V_OLD_DSEMAILFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Email=' + @V_NEW_DSEMAILFORN;
            END;

            IF (ISNULL(@V_NEW_NRDDDTELEFORN,'!') <> ISNULL(@V_OLD_NRDDDTELEFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' DDDTel1=' + @V_NEW_NRDDDTELEFORN;
            END;

            IF (ISNULL(@V_NEW_NRTELEFORN,'!') <> ISNULL(@V_OLD_NRTELEFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Tel1=' + @V_NEW_NRTELEFORN;
            END;

            IF (ISNULL(@V_NEW_NRRAMALFORN,'!') <> ISNULL(@V_OLD_NRRAMALFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' RamalTel1=' + @V_NEW_NRRAMALFORN;
            END;

            IF (ISNULL(@V_NEW_NRDDDTELEFORN1,'!') <> ISNULL(@V_OLD_NRDDDTELEFORN1,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' DDDTel2=' + @V_NEW_NRDDDTELEFORN1;
            END;

            IF (ISNULL(@V_NEW_NRTELEFORN1,'!') <> ISNULL(@V_OLD_NRTELEFORN1,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' Tel2=' + @V_NEW_NRTELEFORN1;
            END;

            IF (ISNULL(@V_NEW_NRRAMALFORN1,'!') <> ISNULL(@V_OLD_NRRAMALFORN1,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' RamalTel2=' + @V_NEW_NRRAMALFORN1;
            END;

            IF (ISNULL(@V_NEW_NRDDDCELULARFOR,'!') <> ISNULL(@V_OLD_NRDDDCELULARFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' DDDCel=' + @V_NEW_NRDDDCELULARFOR;
            END;

            IF (ISNULL(@V_NEW_NRCELULARFOR,'!') <> ISNULL(@V_OLD_NRCELULARFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TelCel=' + @V_NEW_NRCELULARFOR;
            END;

            IF (ISNULL(@V_NEW_NRDDDTELRESIFOR,'!') <> ISNULL(@V_OLD_NRDDDTELRESIFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' DDDResiden=' + @V_NEW_NRDDDTELRESIFOR;
            END;

            IF (ISNULL(@V_NEW_NRTELRESIFOR,'!') <> ISNULL(@V_OLD_NRTELRESIFOR,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TelResiden=' + @V_NEW_NRTELRESIFOR;
            END;

            IF (ISNULL(@V_NEW_NRDDDFAXFORN,'!') <> ISNULL(@V_OLD_NRDDDFAXFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' DDDFax=' + @V_NEW_NRDDDFAXFORN;
            END;

            IF (ISNULL(@V_NEW_NRFAXFORN,'!') <> ISNULL(@V_OLD_NRFAXFORN,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' TelFax=' + @V_NEW_NRFAXFORN;
            END;

            IF (ISNULL(@V_NEW_DSEMAILFORNNFE,'!') <> ISNULL(@V_OLD_DSEMAILFORNNFE,'!')) BEGIN
               SET @V_DESC = @V_DESC + ' EmailNFe=' + @V_NEW_DSEMAILFORNNFE;
            END;

            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDFORNECED;
         END;

         IF @V_TIPO <> '0' BEGIN
            IF NOT @V_DESC IS NULL BEGIN
               SET @V_DESC   = SUBSTRING(@V_DESC, 1, 300);
               INSERT INTO LOGOPERA
                  (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
               VALUES
                  ('ENDEFORN', GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_TIPO, @V_DESC, @V_ITPESQ, @V_DSSERVERRDM,
                   @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER, @V_CDFILLOGOPER);
            END;
         END;

         FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                    @V_OLD_CDFORNECED,      @V_OLD_IDTPENDEFORN, @V_OLD_DSENDEFORN,      @V_OLD_NRENDEFORNSEP,
                                    @V_OLD_DSCOMPENDFOR,    @V_OLD_CDLOGRADOURO, @V_OLD_NMBAIRFORN,      @V_OLD_CDPAIS,
                                    @V_OLD_SGESTADO,        @V_OLD_CDMUNICIPIO,  @V_OLD_NMCONTFORN,      @V_OLD_DSEMAILFORN,
                                    @V_OLD_NRDDDTELEFORN,   @V_OLD_NRTELEFORN,   @V_OLD_NRRAMALFORN,     @V_OLD_NRDDDTELEFORN1,
                                    @V_OLD_NRTELEFORN1,     @V_OLD_NRRAMALFORN1, @V_OLD_NRDDDCELULARFOR, @V_OLD_NRCELULARFOR,
                                    @V_OLD_NRDDDTELRESIFOR, @V_OLD_NRTELRESIFOR, @V_OLD_NRDDDFAXFORN,    @V_OLD_NRFAXFORN,
                                    @V_OLD_DSEMAILFORNNFE,

                                    @V_NEW_CDFORNECED,      @V_NEW_IDTPENDEFORN,      @V_NEW_DSENDEFORN,      @V_NEW_NRENDEFORNSEP,
                                    @V_NEW_DSCOMPENDFOR,    @V_NEW_CDLOGRADOURO, @V_NEW_NMBAIRFORN,      @V_NEW_CDPAIS,
                                    @V_NEW_SGESTADO,        @V_NEW_CDMUNICIPIO,  @V_NEW_NMCONTFORN,      @V_NEW_DSEMAILFORN,
                                    @V_NEW_NRDDDTELEFORN,   @V_NEW_NRTELEFORN,   @V_NEW_NRRAMALFORN,     @V_NEW_NRDDDTELEFORN1,
                                    @V_NEW_NRTELEFORN1,     @V_NEW_NRRAMALFORN1, @V_NEW_NRDDDCELULARFOR, @V_NEW_NRCELULARFOR,
                                    @V_NEW_NRDDDTELRESIFOR, @V_NEW_NRTELRESIFOR, @V_NEW_NRDDDFAXFORN,    @V_NEW_NRFAXFORN,
                                    @V_NEW_DSEMAILFORNNFE;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_ENDEFORN','5.42.xxx';
GO

