#!/bin/bash

# Requisitos
# Android SDK Command Line Tools (https://developer.android.com/studio). Mover o conteudo da pasta para uma nova chamada "latest". Aceitar licencas (yes | android-sdk/cmdline-tools/latest/bin/sdkmanager --licenses)
# Android Build Tools 32 (sdkmanager "build-tools;32.0.0", sdkmanager "platforms;android-32")
# OpenJDK (mkdir -p /usr/share/man/man1; sudo apt install default-jdk)
# SDKMAN! (https://sdkman.io/install)
# Gradle (https://gradle.org/install/)

# Uteis
# Gerar APK pelo AAB: java -jar ~/workfolder/bundletool-all-1.14.0.jar build-apks --bundle=app-release-zip.aab --output=myapp.apks --mode=universal --ks hcm-mobileapps.keystore --ks-key-alias hcmapps
# Bundle Tool (https://developer.android.com/tools/bundletool. wget https://github.com/google/bundletool/releases/download/1.14.0/bundletool-all-1.14.0.jar)

app_version='0.74.0' # Update version before running the script
project_folder=$(pwd)/../portalFuncionario-apk

export JAVA_HOME=/usr/lib/jvm/java-11-openjdk-amd64
export ANDROID_HOME=~/workfolder/android-sdk

git clone git@gitlab.teknisa.com:pebbian/portalFuncionario.git $project_folder

# Caso seja necessario apenas remover os arquivos gerados
# cd $project_folder/mobile
# rm -rf node_modules bower_components package-lock.json

# cd $project_folder/mobile/src-cordova
# rm -rf node_modules package-lock.json plugins platforms www

cd $project_folder/mobile
npm i
bower install
grunt buildEnvironment:production

cd $project_folder/mobile/src/assets/ts/configuration/
sed -i 's/\.\.\//https:\/\/portalfuncionario.teknisa.com\//' Constants.ts
sed -i "s/<>PRODUCT_VERSION<>/$app_version/" Constants.ts

cd $project_folder/mobile/src-cordova
npm i

cd $project_folder/mobile
npm run cordova-prepare

cd $project_folder/mobile/src-cordova
npx cordova@10.0.0 platform remove android
npx cordova@10.0.0 platform add android@11.0.0
sed -i "s/version=\"1.0.3\"/version=\"$app_version\"/" config.xml
npx cordova@10.0.0 build android --release

cd $project_folder/mobile/src-cordova/platforms/android/app/build/outputs/bundle/release
cp $project_folder/apk/hcm-mobileapps.keystore .
$JAVA_HOME/bin/jarsigner -verbose -sigalg SHA1withRSA -digestalg SHA1 -keystore hcm-mobileapps.keystore -storepass "Teknisa@2021" -keypass "Teknisa@2020" app-release.aab hcmapps
$ANDROID_HOME/build-tools/32.0.0/zipalign -v 4 app-release.aab app-release-zip.aab

echo 'Arquivos gerados em ' $project_folder/mobile/src-cordova/platforms/android/app/build/outputs/bundle/release

exit 0
